
#property copyright "*"
#property link      "*"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 DodgerBlue
#property indicator_color3 Red
#property indicator_color4 DodgerBlue
#property indicator_color5 Red
#property indicator_color6 DodgerBlue
#property indicator_color7 Red
#property indicator_color8 DodgerBlue

#property indicator_level1 0

#property indicator_maximum 6
#property indicator_minimum -6

#property indicator_width1 2
#property indicator_width2 2

#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2

#property indicator_width7 2
#property indicator_width8 2

//---- input parameters
extern   double   k1=1.0;
extern   double   k2=3.0;
extern   double   k3=6.0;
extern   double   k4=24.0;



extern int Pr=0;

//---- buffers

double A1[];
double A2[];
double A3[];
double A4[];
double A5[];
double A6[];
double A7[];
double A8[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,0,2);
   SetIndexArrow(0,158);
   SetIndexBuffer(0,A1);
   SetIndexStyle(1,DRAW_ARROW,0,2);
   SetIndexArrow(1,158);
   SetIndexBuffer(1,A2);
   
   SetIndexStyle(2,DRAW_ARROW,0,2);
   SetIndexArrow(2,158);
   SetIndexBuffer(2,A3);
   SetIndexStyle(3,DRAW_ARROW,0,2);
   SetIndexArrow(3,158);
   SetIndexBuffer(3,A4);   
   
   SetIndexStyle(4,DRAW_ARROW,0,2);
   SetIndexArrow(4,158);
   SetIndexBuffer(4,A5);
   SetIndexStyle(5,DRAW_ARROW,0,2);
   SetIndexArrow(5,158);
   SetIndexBuffer(5,A6);   
   
   SetIndexStyle(6,DRAW_ARROW,0,2);
   SetIndexArrow(6,158);
   SetIndexBuffer(6,A7);
   SetIndexStyle(7,DRAW_ARROW,0,2);
   SetIndexArrow(7,158);
   SetIndexBuffer(7,A8);   
   
   
   SetIndexLabel(0,"GMA Quadro");
   SetIndexLabel(1,"GMA Quadro");   
   SetIndexLabel(2,"GMA Quadro");   
   SetIndexLabel(3,"GMA Quadro"); 
   SetIndexLabel(4,"GMA Quadro");
   SetIndexLabel(5,"GMA Quadro");   
   SetIndexLabel(6,"GMA Quadro");   
   SetIndexLabel(7,"GMA Quadro"); 
   
   IndicatorDigits(0);   
   
     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
  double m;
  double c,p;
  static int tr1,tr2,tr3,tr4;
   int limit=Bars-IndicatorCounted();
      for(int i=limit-1;i>=0;i--){
         A1[i]=EMPTY_VALUE;
         A2[i]=EMPTY_VALUE;         
         A3[i]=EMPTY_VALUE;         
         A4[i]=EMPTY_VALUE;         
         A5[i]=EMPTY_VALUE;
         A6[i]=EMPTY_VALUE;         
         A7[i]=EMPTY_VALUE;         
         A8[i]=EMPTY_VALUE;         
               c=IndVal(k1,i+1);
               p=IndVal(k1,i+2);
                  if(c>0 && p<=0)tr1=1;
                  if(c<0 && p>=0)tr1=2;
               c=IndVal(k2,i+1);
               p=IndVal(k2,i+2);
                  if(c>0 && p<=0)tr2=1;
                  if(c<0 && p>=0)tr2=2;     
               c=IndVal(k3,i+1);
               p=IndVal(k3,i+2);
                  if(c>0 && p<=0)tr3=1;
                  if(c<0 && p>=0)tr3=2;     
               c=IndVal(k4,i+1);
               p=IndVal(k4,i+2);
                  if(c>0 && p<=0)tr4=1;
                  if(c<0 && p>=0)tr4=2;  
                  
               if(tr1==1)A7[i]=1; 
               if(tr1==2)A8[i]=-1; 
               
               if(tr2==1)A5[i]=2; 
               if(tr2==2)A6[i]=-2;                
               
               if(tr3==1)A3[i]=3; 
               if(tr3==2)A4[i]=-3; 
               
               if(tr4==1)A1[i]=4; 
               if(tr4==2)A2[i]=-4;                 
               
               
               c=IndVal(k1,i);
               p=IndVal(k1,i+1);
                  if(c>0 && p<=0)A7[i]=1; 
                  if(c<0 && p>=0)A8[i]=-1; 
               c=IndVal(k2,i);
               p=IndVal(k2,i+1);
                  if(c>0 && p<=0)A5[i]=2;
                  if(c<0 && p>=0)A6[i]=-2;       
               c=IndVal(k3,i);
               p=IndVal(k3,i+1);
                  if(c>0 && p<=0)A3[i]=3; 
                  if(c<0 && p>=0)A4[i]=-3;    
               c=IndVal(k4,i);
               p=IndVal(k4,i+1);
                  if(c>0 && p<=0)A1[i]=4; 
                  if(c<0 && p>=0)A2[i]=-4;                
               
               

      }
   return(0);
  }
//+------------------------------------------------------------------+

double IndVal(double Koef,int Ind){
   double c=0;
   double m=0;
      m=iMACD(NULL,0,Koef*3,Koef*30,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;         
      m=iMACD(NULL,0,Koef*5,Koef*35,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;                    
      m=iMACD(NULL,0,Koef*8,Koef*40,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;          
      m=iMACD(NULL,0,Koef*10,Koef*45,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;   
      m=iMACD(NULL,0,Koef*12,Koef*50,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;
      m=iMACD(NULL,0,Koef*15,Koef*60,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;
   return(c);
}